Extra Features
==============

The default interface of the Red Matrix was designed to be uncluttered. There are a huge number of extra features (some of which are extremely useful) which you can turn on and get the most of the application. These are found under the [Extra Features](settings/features) link of your [Settings](settings) page.

**Content Expiration** 

Remove posts/comments and/or private messages at a future time. An extra button is added to the post editor which asks you for an expiration. Typically this in "yyyy-mm-dd hh:mm" format, but in the English language you have a bit more freedom and can use most any recognisable date reference such as "next Thursday" or "+1 day". At the specified time (give or take approximately ten minutes based on the remote system's checking frequency) the post is removed. 
 
**Multiple Profiles**

The ability to create multiple profiles which are visible only to specific persons or groups. Your default profile may be visible to anybody, but secondary profiles can all contain different or additional information and can only be seen by those to whom that profile is assigned.
 
**Web Pages**

Provides the ability to use web page design feaures and create custom webpages from your own content and also to design the pages with page layouts, custom menus, and content blocks.

**Enhanced Photo Albums**

Provides a photo album viewer that is a bit prettier than the normal interface.

**Extended Identity Sharing**

By default your identity travels with you as you browse the matrix to remote sites - and they know who you are and can show you content that only you can see. With Extended Identity Sharing you can provide this information to any website you visit from within the matrix. 

**Expert Mode**

This allows you to see some advanced configuration options that would confuse some people or cause support issues. In particular this can give you full control over theme features and colours - so that you can tweak a large number of settings of the display theme to your liking. 

**Premium Channel**

This allows you to set restrictions and terms on those that connect with your channel. This may be used by celebrities or anybody else who wishes to describe their channel to people who wish to connect with it. In certain cases you may be asked for payment in order to connect.  


**Richtext Editor**

The status post editor is plaintext, but the matrix allows a wide range of markup using BBcode. The visual editor provides "what you see is what you get" for many of the most frequently used markup tags. 

**Post Preview**

Allows previewing posts and comments exactly as they would look on the page before publishing them.

**Channel Sources**

Automatically import and re-publish channel content from other channels or feeds. This allows you to create sub-channels and super-channels from content provided elsewhere. The rules are that the content must be public, and the channel owner must give you permission to source their channel.

**Even More Encryption**

Private messages are encrypted during transport and storage. In this day and age, this encyption may not be enough if your communications are extremely sensitive. This options lets you provide optional encryption of content "end-to-end" with a shared secret key. How the recipient learns the secret key is completely up to you. You can provide a hint such as "the name of aunt Claire's first dog". 
 

**Search by Date**

This provides the ability to select posts by date ranges

**Collections Filter**

Enable widget to display stream posts only from selected collections. This also toggles the outbound permissions while you are viewing a collection. This is analogous to Google "circles" or Disapora "aspects". 

**Saved Searches**

Provides a search widget on your matrix page which can save selected search terms for re-use.

**Personal Tab**

Enable tab to display only matrix posts that you've interacted with in some way, as an author or a contributor to the conversation.

**New Tab**

Enables a tab to display all new matrix activity as a firehose or timeline.

**Affinity Tool**

Filter matrix stream activity by the depth of your relationships

**Edit Sent Posts**

Edit and correct posts and comments after sending

**Tagging**

Ability to tag existing posts, including those written by others.

**Post Categories**

Add categories to your channel posts

**Saved Folders**

Ability to file posts under folders or tags for later recall

**Dislike Posts**

Ability to dislike posts/comments

**Star Posts**

Ability to mark special posts with a star indicator

**Tag Cloud**

Provide a personal tag cloud on your channel page

